package com.danitheskunk.skunkgame;

import com.danitheskunk.skunkworks.Vec2i;

public class Building {
	private final String name;
	private final String displayName;
	private int count;
	private Button button;
	private final Cost cost;

	public Building(String name, String displayName, Cost cost) {
		this.name = name;
		this.displayName = displayName;
		this.cost = cost;
		this.count = 0;
		this.button = new Button(Vec2i.ZERO, displayName);
		this.button.onClick(() -> {
			if(canAfford()) {
				buy();
			}
		});
	}

	public void setButtonPos(Vec2i pos) {
		button.setPos(pos);
	}

	public boolean canAfford() {
		return cost.canAfford();
	}

	public void buy() {
		if(cost.canAfford()) {
			cost.use();
			count += 1;
			button.setCount(count);
		}
	}

	public boolean isButtonVisible() {
		return count > 0 || canAfford();
	}

	public Button getButton() {
		return button;
	}

	public String getName() {
		return name;
	}

	public int getCount() {
		return count;
	}
}
